#ifndef _REGCACHE_H__1964_
#define _REGCACHE_H__1964_


typedef struct x86regtyp
{
    _int8 mips_reg;
    _int16 x86reg;
    _int8 IsDirty;
    _int8 Is32bit;

} x86regtyp;


//Note: i'm skipping EBP and ESP and ESI on purpose!
#define PUSHALL                 \
{                               \
    _asm {  push eax }          \
    _asm {  push ebx }          \
    _asm {  push ecx }          \
    _asm {  push edx }          \
    _asm {  push edi }          \
}
#define POPALL                  \
{                               \
    _asm {  pop  edi }          \
    _asm {  pop  edx }          \
    _asm {  pop  ecx }          \
    _asm {  pop  ebx }          \
    _asm {  pop  eax }          \
}

//I'm skipping EBP and ESP and ESI on purpose!
#define recPUSHALL                                  \
{                                                   \
                                                    \
/*0044DD57 50                   push        eax */  \
/*0044DD58 51                   push        ecx */  \
/*0044DD59 52                   push        edx */  \
/*0044DD5A 53                   push        ebx */  \
/*0044DD5B 54                   push        esp */  \
/*0044DD5C 55                   push        ebp */  \
/*0044DD5D 56                   push        esi */  \
/*0044DD5E 57                   push        edi */  \
    PUTDST32KNOWN(Dest, 0x53525150)                 \
    /*PUTDST8KNOWN(Dest, 0x56)*/    PUTDST8KNOWN(Dest, 0x57)    \
}
#define recPOPALL                                   \
{                                                   \
/*0044DDF3 5F                   pop         edi */  \
/*0044DDF2 5E                   pop         esi */  \
/*0044DDF1 5D                   pop         ebp */  \
/*0044DDF0 5C                   pop         esp */  \
/*0044DDEE 5B                   pop         ebx */  \
/*0044DDEF 5A                   pop         edx */  \
/*0044DDED 59                   pop         ecx */  \
/*0044DDEC 58                   pop         eax */  \
    PUTDST8KNOWN(Dest, 0x5F)    PUTDST32KNOWN(Dest, 0x58595A5B) \
}


#define PUSHECX PUTDST8KNOWN(Dest, 0x51)
#define POPECX  PUTDST8KNOWN(Dest, 0x59)


/*****************************************************************
                   Function Declarations
/*****************************************************************/

extern uint8* FlushAllRegisters32(uint8* Dest);
extern void RecFlushAllRegisters32();
extern uint8* FlushAllBut2(uint8* Dest, _int8 The1stOneNotToFlush, _int8 The2ndOneNotToFlush);
extern uint8* ForceMapRegister32(uint8* Dest, uint8 MIPS_Reg, _int8* Success, int WriteCode, uint8 IsDirty, uint8 k);
extern uint8* MapRegister32(uint8* Dest, x86regtyp* Conditions);
extern void InitRegisterMap();
extern uint32 InterruptWasExecuted;

//---------------------------------------------------------------------------------------
#define recPUSHEAX  PUTDST8KNOWN(Dest, 0x50)
#define recPOPEAX   PUTDST8KNOWN(Dest, 0x58)

#define rc_CompMIPS32RegTo0(Dest, Map)          \
{                                               \
    Map                                         \
    /* test r32,r32 */                          \
    r32_r32(op  , RS_mapped[0], RS_mapped[0]);  \
}


extern RETURN_TYPE rc_Intr_Common(uint8* Dest);

extern RETURN_TYPE (*rc_CPU_instruction[64])(       OP_PARAMS);
extern RETURN_TYPE (*rc_SPECIAL_Instruction[64])(   OP_PARAMS);
extern RETURN_TYPE (*rc_REGIMM_Instruction[32])(    OP_PARAMS);
extern RETURN_TYPE (*rc_COP0_Instruction[32])(      OP_PARAMS);
extern RETURN_TYPE (*rc_TLB_Instruction[64])(       OP_PARAMS);
extern RETURN_TYPE (*rc_COP1_Instruction[32])(      OP_PARAMS);
extern RETURN_TYPE (*rc_COP1_BC_Instruction[4])(    OP_PARAMS);
extern RETURN_TYPE (*rc_COP1_S_Instruction[64])(    OP_PARAMS);
extern RETURN_TYPE (*rc_COP1_D_Instruction[64])(    OP_PARAMS);
extern RETURN_TYPE (*rc_COP1_W_Instruction[64])(    OP_PARAMS);
extern RETURN_TYPE (*rc_COP1_L_Instruction[64])(    OP_PARAMS);
extern RETURN_TYPE rc_UNUSED(                       OP_PARAMS);
extern RETURN_TYPE rc_r4300i_cache(             OP_PARAMS);
extern RETURN_TYPE rc_r4300i_daddiu(                OP_PARAMS);
extern RETURN_TYPE rc_r4300i_lb(                    OP_PARAMS);
extern RETURN_TYPE rc_r4300i_lbu(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_ld(                    OP_PARAMS);
extern RETURN_TYPE rc_r4300i_ldl(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_ldr(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_lh(                    OP_PARAMS);
extern RETURN_TYPE rc_r4300i_lhu(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_ll(                    OP_PARAMS);
extern RETURN_TYPE rc_r4300i_lld(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_lw(                    OP_PARAMS);
extern RETURN_TYPE rc_r4300i_lwl(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_lwr(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_lwu(                   OP_PARAMS); 
extern RETURN_TYPE rc_r4300i_sb(                    OP_PARAMS); 
extern RETURN_TYPE rc_r4300i_sc(                    OP_PARAMS);
extern RETURN_TYPE rc_r4300i_scd(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_sd(                    OP_PARAMS);
extern RETURN_TYPE rc_r4300i_sdl(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_sdr(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_sh(                    OP_PARAMS);
extern RETURN_TYPE rc_r4300i_sw(                    OP_PARAMS);
extern RETURN_TYPE rc_r4300i_swl(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_swr(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_ldc1(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_lwc1(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_sdc1(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_swc1(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_lui(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_addiu(             OP_PARAMS);
extern RETURN_TYPE rc_r4300i_addi(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_andi(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_daddi(             OP_PARAMS);
extern RETURN_TYPE rc_r4300i_ori(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_slti(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_sltiu(             OP_PARAMS);
extern RETURN_TYPE rc_r4300i_xori(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_beq(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_beql(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_bne(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_bnel(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_jal(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_ldc2(                  OP_PARAMS);  
extern RETURN_TYPE rc_r4300i_swc2(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_bltz(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_bgez(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_bltzl(             OP_PARAMS);
extern RETURN_TYPE rc_r4300i_bgezl(             OP_PARAMS);
extern RETURN_TYPE rc_r4300i_tgei(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_tgeiu(             OP_PARAMS);
extern RETURN_TYPE rc_r4300i_tlti(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_tltiu(             OP_PARAMS);
extern RETURN_TYPE rc_r4300i_teqi(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_tnei(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_bltzal(                OP_PARAMS);
extern RETURN_TYPE rc_r4300i_bgezal(                OP_PARAMS);
extern RETURN_TYPE rc_r4300i_bltzall(               OP_PARAMS);
extern RETURN_TYPE rc_r4300i_bgezall(               OP_PARAMS);
extern RETURN_TYPE rc_r4300i_sll(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_srl(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_sra(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_sllv(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_srlv(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_srav(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_jr(                    OP_PARAMS);
extern RETURN_TYPE rc_r4300i_jr_runtime(            OP_PARAMS);
extern RETURN_TYPE rc_r4300i_jalr(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_syscall(               OP_PARAMS);
extern RETURN_TYPE rc_r4300i_Break(             OP_PARAMS);
extern RETURN_TYPE rc_r4300i_sync(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_mfhi(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_mthi(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_mflo(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_mtlo(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_dsllv(             OP_PARAMS);
extern RETURN_TYPE rc_r4300i_dsrlv(             OP_PARAMS);
extern RETURN_TYPE rc_r4300i_dsrav(             OP_PARAMS);
extern RETURN_TYPE rc_r4300i_mult(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_multu(             OP_PARAMS);
extern RETURN_TYPE rc_r4300i_div(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_divu(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_dmult(             OP_PARAMS);
extern RETURN_TYPE rc_r4300i_dmultu(                OP_PARAMS);
extern RETURN_TYPE rc_r4300i_ddiv(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_ddivu(             OP_PARAMS);
extern RETURN_TYPE rc_r4300i_add(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_addu(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_sub(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_subu(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_and(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_or(                    OP_PARAMS);
extern RETURN_TYPE rc_r4300i_xor(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_nor(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_slt(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_sltu(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_dadd(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_daddu(             OP_PARAMS);
extern RETURN_TYPE rc_r4300i_dsub(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_dsubu(             OP_PARAMS);
extern RETURN_TYPE rc_r4300i_tge(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_tgeu(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_tlt(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_tltu(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_teq(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_tne(                   OP_PARAMS);
extern RETURN_TYPE rc_r4300i_dsll(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_dsrl(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_dsra(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_dsll32(                OP_PARAMS);
extern RETURN_TYPE rc_r4300i_dsrl32(                OP_PARAMS);
extern RETURN_TYPE rc_r4300i_dsra32(                OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP0_mfc0(         OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP0_mtc0(         OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_cfc1(         OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_ctc1(         OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_dmfc1(            OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_dmtc1(            OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_mfc1(         OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_mtc1(         OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_add_s(            OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_add_d(            OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_sub_s(            OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_sub_d(            OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_mul_s(            OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_mul_d(            OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_div_s(            OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_div_d(            OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_sqrt_s(           OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_sqrt_d(           OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_abs_s(            OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_abs_d(            OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_mov_s(            OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_mov_d(            OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_neg_s(            OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_neg_d(            OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_roundl(           OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_truncl(           OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_ceill(            OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_floorl(           OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_roundw(           OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_truncw_s(     OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_truncw_d(     OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_ceilw(            OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_floorw(           OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_cvts_d(           OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_cvts_w(           OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_cvts_l(           OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_cvtd_s(           OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_cvtd_w(           OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_cvtd_l(           OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_cvtw_s(           OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_cvtw_d(           OP_PARAMS); 
extern RETURN_TYPE rc_r4300i_COP1_cvtw_l(           OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_cvtl_s(           OP_PARAMS); 
extern RETURN_TYPE rc_r4300i_COP1_cvtl_d(           OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_F_S(             OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_F_D(             OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_UN_S(                OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_UN_D(                OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_EQ_S(                OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_EQ_D(                OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_UEQ_S(               OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_UEQ_D(               OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_OLT_S(               OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_OLT_D(               OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_ULT_S(               OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_ULT_D(               OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_OLE_S(               OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_OLE_D(               OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_ULE_S(               OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_ULE_D(               OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_SF_S(                OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_SF_D(                OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_NGLE_S(              OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_NGLE_D(              OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_SEQ_S(               OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_SEQ_D(               OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_NGL_S(               OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_NGL_D(               OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_LT_S(                OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_LT_D(                OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_NGE_S(               OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_NGE_D(               OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_LE_S(                OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_LE_D(                OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_NGT_S(               OP_PARAMS);
extern RETURN_TYPE rc_r4300i_C_NGT_D(               OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_bc1f(         OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_bc1t(         OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_bc1fl(            OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP1_bc1tl(            OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP0_tlbr(         OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP0_tlbwi(            OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP0_tlbwr(            OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP0_tlbp(         OP_PARAMS);
extern RETURN_TYPE rc_r4300i_COP0_eret(         OP_PARAMS);
extern RETURN_TYPE rc_r4300i_j(                 OP_PARAMS);
extern RETURN_TYPE rc_r4300i_blez(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_bgtz(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_blezl(             OP_PARAMS);
extern RETURN_TYPE rc_r4300i_bgtzl(             OP_PARAMS);
extern RETURN_TYPE rc_r4300i_break(             OP_PARAMS);
extern RETURN_TYPE rc_r4300i_sync(                  OP_PARAMS);
extern RETURN_TYPE rc_r4300i_syscall(               OP_PARAMS);
extern RETURN_TYPE rc_temp_NOP(                 OP_PARAMS);

#endif //_REGCACHE_H__1964_
